/*
 * Private Definition for ArrangeBox
 */

#ifndef _ArrangeBoxP_h
#define _ArrangeBoxP_h

#ifdef X11R5
#include <X11/Xaw/BoxP.h>
#else
#include <X11/BoxP.h>
#endif
#include "ArrangeBox.h"

typedef struct {
	int vert_num;
	int arrange_order;
	Boolean resize_parent;
} ArrangeBoxPart;

typedef struct _ArrangeBoxRec {
	CorePart	core;
	CompositePart	composite;
	BoxPart		box;
	ArrangeBoxPart	arrange_box;
} ArrangeBoxRec;

typedef struct {
	AiSortProc	sort_children;
} ArrangeBoxClassPart;

typedef struct _ArrangeBoxClassRec {
	CoreClassPart		core_class;
	CompositeClassPart	composite_class;
	BoxClassPart		box_class;
	ArrangeBoxClassPart	arrange_box_class;
} ArrangeBoxClassRec;

extern ArrangeBoxClassRec	arrangeBoxClassRec;

#define AiInheritSortChildren	((AiSortProc)_XtInherit)
#endif
