/*
 * Private definition for LabeledPicture widget
 */

#include "LabeledPicture.h"
#include <X11/CoreP.h>

#define	ST_SELECT	1
#define ST_INVERSE	2
#define ST_INIT_WIDTH	4
#define ST_INIT_HEIGHT	8

typedef struct {
/* Resources */
	char*		label;
	Pixmap		pixmap;
	XFontStruct	*font;
	Pixel		foreground;
	int		label_margin;
	int		side_margin;
	XtCallbackList	callback;
	Boolean		sensitive;
	TextPosition	position;
/* Other data */
	int		pixmap_width;
	int		pixmap_height;
	int		label_width;
	GC		label_GC;
	GC		picture_GC;
	short		status;
	Boolean		pixmap_is_bitmap;
} LabeledPicturePart;

typedef struct _LabeledPictureRec {
	CorePart		core;
	LabeledPicturePart	labeled_picture;
} LabeledPictureRec;

typedef struct { int dummy; } LabeledPictureClassPart;

typedef struct _LabeledPictureClassRec {
	CoreClassPart	core_class;
	LabeledPictureClassPart	labeled_picture_class;
} LabeledPictureClassRec;

extern LabeledPictureClassRec	labeledPictureClassRec;

