/*
 * Private definition for LoadFace widget
 */

#include "LabeledPictureP.h"
#include "LoadFace.h"
#include <protocols/rwhod.h>

typedef struct {
/* Resources */
	char	*bitmap_file_directory;
	Boolean	widget_specific_bitmap;
	int interval;
	char *whod_directory;
	Boolean shuffle;
	AiLoadBound load_bound;
/* Other data */
	struct whod site_data;
	AiFacesData faces_data;
	XtIntervalId interval_id;
} LoadFacePart;

typedef struct _LoadFaceRec {
	CorePart		core;
	LabeledPicturePart	labeled_picture;
	LoadFacePart		load_face;
} LoadFaceRec;

typedef struct {
	AiFacesData	faces_data;
	Boolean		faces_data_initialized;
} LoadFaceClassPart;

typedef struct _LoadFaceClassRec {
	CoreClassPart	core_class;
	LabeledPictureClassPart	labeled_picture_class;
	LoadFaceClassPart	load_face_class;
} LoadFaceClassRec;

extern LoadFaceClassRec loadFaceClassRec;
