/*
 * Private definition for MachineInfo widget 
 */
#include "MachineInfo.h"
#include <X11/CoreP.h>
#include <protocols/rwhod.h>

typedef struct {
	/* Resources */
	XFontStruct	*title_font;
	XFontStruct	*load_info_font;
	XFontStruct	*user_info_font;
	Pixel		foreground;
	struct whod	*site_info;
	/* Private */
	GC		title_GC;
	GC		load_info_GC;
	GC		user_info_GC;
	GC		user_info_gray_GC;
} MachineInfoPart;

typedef struct _MachineInfoRec {
	CorePart	core;
	MachineInfoPart	machine_info;
} MachineInfoRec;

typedef struct { int dummy; } MachineInfoClassPart;

typedef struct _MachineInfoClassRec {
	CoreClassPart		core_class;
	MachineInfoClassPart	machine_info_class;
} MachineInfoClassRec;

extern MachineInfoClassRec machineInfoClassRec;
