#include <X11/IntrinsicP.h>
#include <X11/CoreP.h>
#include <X11/CompositeP.h>
#include <X11/Xaw/BoxP.h>

/*
 *  Access Functions to core
 */

void
queryFigure(w,x,y,width,height)
Widget w;
int *x,*y;
int *width,*height;
{
	if (x) *x = w->core.x;
	if (y) *y = w->core.y;
	if (width) *width = w->core.width;
	if (height) *height = w->core.height;
}

int
queryBorderWidth(w)
Widget w;
{
	return w->core.border_width;
}

/*
 *  Access functions to composite
 */
queryNumberOfChild(w)
CompositeWidget w;
{
	return w->composite.num_children;
}

WidgetList
queryChild(w)
CompositeWidget w;
{
	return w->composite.children;
}

/*
 *  Access functions to Box
 */
queryBoxSpace(w,h,v)
BoxWidget w;
int *h,*v;
{
	*h = w->box.h_space;
	*v = w->box.v_space;
}
